### clp_ga_crossing_over.py
from random import randint
from clp_ga_bewertung import bewerte

# Das crossing-over ist sehr viel schwerer zu realisieren.
# Eine Moeglichkeit besteht darin, mehrere Container aus einem
# Individuum mit denen aus einem anderen dann auszutauschen,
# wenn dabei jeweils zulaessige Loesungen entstehen.
# (--> "lebensfaehig")
# Die vorhandenen Stuecke werden in crossingOver aus dem ersten
# pool-Element bestimmt und uebergeben
### ----- crossingOver -----
# steuert das crossing-over ueber den pool
def crossingOver(anzahl, pool):
    # Bestimmung der stuecke
    stuecke=[]
    for cont in pool[0]:
        stuecke+=cont[1]
    akku=[]
    for i in range(anzahl):
        a,b=randint(1,len(pool[i])),randint(1,len(pool[i]))
        if a<b: von,bis=a,b # von<=bis gewaehrleisten
        else:von,bis=b,a
        akku+=cross(von,bis,
                    pool[randint(0,len(pool)-1)],
                    pool[randint(0,len(pool)-1)],
                    stuecke)
    return akku+pool

### ----- cross -----
# Vorbedingung: von >= 1  und bis <= Anzahl Container
def cross(von, bis, liste1, liste2, stuecke):
    ##print(liste1,'\n',liste2,'\n')
    erg1=lebensfaehig(fuelleUm(von,bis,
                               liste1[1:],  # nicht eingefuellte abschneiden
                               liste2[1:]), # nicht eingefuellte abschneiden
                      stuecke)              # alle Stuecke
    erg2=lebensfaehig(fuelleUm(von,bis,
                               liste2[1:],  # nicht eingefuellte abschneiden
                               liste1[1:]), # nicht eingefuellte abschneiden
                      stuecke)              # alle Stuecke
    alle=[]
    ##input(('cross',erg1,erg2))
    if erg1: alle.append(erg1)
    else: alle.append(liste1)
    if erg2: alle.append(erg2)
    else: alle.append(liste2)
    ##input(('cross',erg1,erg2))
    return alle


### ----- fuelleUm -----
# fuellt mit den Containern der jeweils anderen Liste
# rekursiv realisiert
def fuelleUm(von, bis, liste1, liste2):
    if len(liste1)==0: # notwendig?
        return liste1, liste2
    erg=liste1[:von]+liste2[von:bis]+liste1[bis:]
    ##input(('fuelleUm',erg))
    return erg

### ----- lebensfaehig -----
# Testet, ob die Loesung zulaessig ist, also nur vorhandene Stuecke eingeladen wurden.
# Wenn nein, gibt die Funktion False zurueck,
# sonst die richtige Containerliste mit der Liste der nicht eingefuellten davor.
def lebensfaehig(containerliste, stuecke):
    ##print('lebensfaehig',stuecke, containerliste)
    verbleibende=[]+stuecke # echte Kopie
    eingefuellte=[]     # alle in den Containern enthaltenen Stuecke
    for container in containerliste:
        eingefuellte+=container[1]
    ##print('eingefuellte',eingefuellte)
    for stueck in eingefuellte:
        if stueck in verbleibende:
            verbleibende.remove(stueck)
        else:
            return False
    ##print('verbleibende',verbleibende)
    ##print('lebensfaehig',[[0, verbleibende]]+containerliste)
    return [[0, verbleibende]]+containerliste

### Tests:
##from clp_ga_bewertung import *
##stuecke=[20,10,10,40,30,20,10,  30,20,30,20]
##pool=[[[0,[20,10,10,40,30,20,10]], [100, [30]], [80, [20]], [50, [30,20]]],
##      [[0,[20,10,10,40,30,20,10]], [100, [30]], [80, [30, 20]], [50, [20]]],
##      [[0,[20,10,10,40,30,20,20,10]], [100, [30]], [80, [20, 20]], [50, [30]]],
##      [[0,[30,30,20,10,10,40,30,20,10]], [100, []], [80, [20]], [50, [20]]]
##      ]
##print(cross(1, 2,
##      [[0,[20,10,10,40,30,20,10]], [100, [30]], [80, [30, 20]], [50, [20]]],
##      [[0,[20,10,10,40,30,20,20,10]], [100, [30]], [80, [20, 20]], [50, [30]]],
##      stuecke))
##def Ausgabe_crossingOver():
##    for contListe in pool:
##        print(contListe)
##        print(bewerte(contListe))
##    print('nach crossingOver')
##    anzahl=len(pool)
##    for containerListe in crossingOver(anzahl,crossingOver(anzahl,pool)):
##        print(containerListe)
##        print(bewerte(containerListe))
##Ausgabe_crossingOver()


