### clp_ga_pool.py
from random import randint

### ===== POOL =====
# Erzeugen des POOLs.
# Es werden n verschiedene zufaellig gefuellte Containerlisten erzeugt.
def erzeugePool(n, containerListe):
    pool=[]
    for i in range(n):
        eineListe=[]+containerListe #echte Kopie
        pool.append(erzeugePoolElement(eineListe))
    return pool

### ----- erzeugePoolElement -----
# Aus der Stueckeliste werden in jeden Container gerade soviel Stuecke getan
# bis er nicht ueberfuellt ist.
# Achtung: die Containerliste enthaelt hier nur die tatsaechlichen Container! 
def erzeugePoolElement(containerListe):
    poolElement=[]
    dieStuecke=[]+containerListe[0][1] # echte Kopie
    for container in containerListe[1:]:
        dieStuecke=[]+umbau(dieStuecke)
        inhalt=[]
        i=0
        while i<len(dieStuecke) and container[0]>sum(inhalt)+dieStuecke[i]:
            inhalt.append(dieStuecke[i])
            i+=1
        dieStuecke=dieStuecke[i:]
        container=[container[0], inhalt]
        poolElement.append(container)
    poolElement=[[0, dieStuecke]]+poolElement
    return poolElement

### ----- umbau -----
# die Liste der vorhandenen Stuecke wird zufaellig neu gebildet
def umbau(dieStuecke):
    alte=[]+dieStuecke # echte Kopie
    neue=[]
    while len(alte)>1:
        i=randint(1,len(alte))-1
        neue.append(alte[i])
        alte=alte[:i]+alte[(i+1):]
    neue.append(alte[0])
    return neue

### ----- Ausgabe -----
##def AusgabePool(pool):
##    for individuum in pool:
##        print(individuum[0][1])
##        for container in individuum[1:]:
##            print(container)
##        print()
##    print()
##    ##return pool

### ----- Test -----
##from clp_ga_daten import *
##pool=erzeugePool(10, containerListe) # enthaelt die stuecke
##AusgabePool(erzeugePool(3, containerListe))
